import java.io.PrintWriter;
import java.io.IOException;
import java.util.List;
import java.io.File;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;


public class IndexDatabase {

    public static void greyLvl_write(PrintWriter writer, int bins, JPicture img){
        float[] res = img.ComputeGrayLevelHistogram(bins);
        String line = "";

        for ( int i = 0 ; i < res.length ; i++ ) {
            line += res[i] + " ";
        }

        writer.println(line);
    }

    public static void RGBLvl_write(PrintWriter writer, int bins, JPicture img){
        float[][][] res = img.ComputeRGBHistogram(bins);
        String line = "";

        for ( int i = 0 ; i < bins ; i++ ) {
            for ( int j = 0 ; j < bins ; j++ ) {
                for ( int k = 0 ; k < bins ; k++ ) {
                    line += res[i][j][k] + " ";
                }
            }
        }

        writer.println(line);
    }


    public static void main(String[] args) {
        try{
            /* Traitement des arguments */

            /* Le premier argument est le fichier listant les images,
			on en fait une liste*/
            List<String> imgList = Files.readAllLines(Paths.get(args[0]));

            /* Le second argument est le chemin vers le dossier des images.*/
            String imgDir = args[1];


            /* Définition des variables */

            /*Le chemin de l'image courante*/
            String imgPath;

            /*L'image en cours de traitement*/
            JPicture image = new JPicture();

            /*Les fichiers de résultats*/
            PrintWriter GrayHist = new PrintWriter("GrayHistogram.txt", "UTF-8");
            PrintWriter RGBHist222 = new PrintWriter("RGBHistogram222.txt", "UTF-8");
            PrintWriter RGBHist444 = new PrintWriter("RGBHistogram444.txt", "UTF-8");
            PrintWriter RGBHist666 = new PrintWriter("RGBHistogram666.txt", "UTF-8");


            /* Traitement */
            for (int i = 0 ; i < imgList.size() ; i++) {
                imgPath = imgDir + "/" + imgList.get(i);
                System.out.println(imgPath);
                image = new JPicture(imgPath);
                greyLvl_write(GrayHist,256, image);
                RGBLvl_write(RGBHist222,2, image);
                RGBLvl_write(RGBHist444,4, image);
                RGBLvl_write(RGBHist666,6, image);
            }

            GrayHist.close();
            RGBHist222.close();
            RGBHist444.close();
            RGBHist666.close();

            System.out.println("Done");
        } 

        // Traitement des erreurs
        catch (IOException ex) {
            ex.printStackTrace();
            System.out.println(ex.getMessage());
        }
    }
}
