# Documentation de la classe IndexDatabase

## main

### Rôle de la classe

Cette classe génère les 4 fichiers d'histogrammes voulus, en générant 4 histogramme pour chacune des images de la base.

### Entrées
Sauf indication contraire, les chemins donnés en arguments devront être relatif.

Les arguments en ligne de commande sont, dans cet ordre :
1. le fichier listant les images (*Base10000/Base10000_files.txt*)
2. le dossier des images (*Base10000/images*)

### Sorties

Le programme génère 4 fichiers d'histogrammes dans le répertoire courant :
* Base10000.HistGREY_256 ;
* Base10000.HistRGB_2x2x2 ;
* Base10000.HistRGB_4x4x4 ;
* Base10000.HistRGB_6x6x6.

De plus, le nom de chaque image traitée apparaît au fur et à mesure à l'écran.

### Utilisation concrète

En considérant qu'on exécute le java depuis le répertoire Java/ de l'arborescence suivante : 

	.
	├── Base10000/
	│   ├── images/
	│   └── Base10000_files.txt
	└── Java/

La commande à lancer sera : 
```
java IndexDatabase ../Base10000/Base10000_files.txt ../Base10000/images
```

## Méthodes de la classe

### `public static void greyLvl_write(PrintWriter writer, int bins, JPicture img);`

#### Rôle de la méthode

Cette méthode génère l'histogramme en niveau de gris d'une image donnée pour un nombre de bins donné, et l'ajoute (en tant que ligne) au fichier des histogrammes en niveaux de gris.

#### Description des arguments

* `writer` : objet représentant un stream dans un fichier, pour y écrire une ligne ;
* `bins` : nombre de bins pour générer l'histogramme en niveaux de gris de l'image ;
* `img` : objet JPicture correspondant à l'image.

### `public static void RGBLvl_write(PrintWriter writer, int bins, JPicture img);`

#### Rôle de la méthode

Cette méthode génère l'histogramme en RGB d'une image donnée pour un nombre de bins donné, et l'ajoute (en tant que ligne) au fichier des histogrammes en RGB de ce nombre de bins.

#### Description des arguments

* `writer` : objet représentant un stream dans un fichier, pour y écrire une ligne ;
* `bins` : nombre de bins par couleur pour générer l'histogramme RGB de l'image ;
* `img` : objet JPicture correspondant à l'image.
