# Documentation de la classe QBE

## main

### Rôle de la classe

Cette classe implémente la recherche par similarité (Query By Example). Pour une image donnée, elle fourni les k images les plus proches selon l'histogramme donné.

### Entrées

Sauf indication contraire, les chemins donnés en arguments devront être relatif.

Les arguments en ligne de commande sont, dans cet ordre :
1. le fichier listant les images (*Base10000/Base10000_files.txt*)
2. le fichier de descripteurs à utiliser (les histogrammes)
3. l'image de la requête
4. nombre de résultats souhaités

### Sorties

Le programme génère un document html dans lequel il source l'image de requête et les k images trouvées estimées les plus proches.

De plus, pour chacune des k images sélectionnées, la distance à l'image de requête apparait à l'écran.

### Utilisation concrète

En considérant qu'on exécute le java depuis le répertoire Java/ de l'arborescence suivante : 

	.
	├── Base10000/
	│   ├── images/
	│   └── Base10000_files.txt
	└── Java/

La commande à lancer pour trouver les 10 meilleurs résultats pour l'image 208055.jpg selon un histogramme RGB 6x6x6 sera : 
```
java QBE ../Base10000/Base10000_files.txt Base10000.HistRGB_6x6x6 208055.jpg 10
```

## Méthodes de la classe

### `public static void dL2(double[] x, double[] y, int n);`

#### Rôle de la méthode

Cette méthode renvoie la distance de type L2 entre les vecteurs x et y. Il s'agit de la racine de la somme des carrés des différences de chaque coordonnées.

#### Description des arguments

* `x` : premier vecteur ;
* `y` : second vecteur de même dimension que le premier;
* `n` : taille des vecteurs.
